#!/usr/bin/python

#
# Copyright (C) 2008 by OpenMoko, Inc.
# Written by Willie Chen <willie_chen@openmoko.com>
# All Rights Reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

import etk
import edje
import os
import re

from expos import *

etk.theme_widget_set_from_path("/usr/share/diversity-nav/default.edj")

def debug(msg):
	print msg
	pass

def clicked(button):
	print "Clicked in item", button
	if re.match('\[\'GSM', str(button)):
		#GSM works
		debug('GSM')
		if gsm.check_onoff():
			gsm.power_off()
		else:
			gsm.power_on()
		lst.freeze()
		button[1]=label_text(button[0])
		lst.thaw()
	if re.match('\[\'WiFi', str(button)):
		#WiFi works
		debug('WiFi')
	if re.match('\[\'Bluetooth', str(button)):
		#Bluetooth works
		debug('Bluetooth')
		if bt.check_onoff():
			bt.power_off()
		else:
			bt.power_on()
		lst.freeze()
		button[1]=label_text(button[0])
		lst.thaw()
	if re.match('\[\'GPS', str(button)):
		#GPS works
		debug('GPS')
		if gps.check_onoff():
			gps.power_off()
		else:
			gps.power_on()
		lst.freeze()
		button[1]=label_text(button[0])
		lst.thaw()
	if re.match('\[\'Display', str(button)):
		#Display works
		debug('Display')
	if re.match('\[\'Sound', str(button)):
		#Sound Effects works
		debug('Sound Effects')
	if re.match('\[\'Ringtones', str(button)):
		#Ringtones works
		debug('Ringtones')
	if re.match('\[\'Vibrate', str(button)):
		#Vibrate works
		debug('Vibrate')

def	check_status(item):
	if re.match('GSM', item):
		if gsm.check_onoff():
			return 'on'
		else:
			return 'off'
	if re.match('Bluetooth', item):
		if bt.check_onoff():
			return 'on'
		else:
			return 'off'
	if re.match('GPS', item):
		if gps.check_onoff():
			return 'on'
		else:
			return 'off'
	else:
		return ''

def label_text(item):
    return "<font_size=48>"+item+"<font_size=24>"+'  '+check_status(item)

main_box = etk.VBox()
model = etk.ListModel()
ktr = etk.KineticTextRenderer(slot=1, click=clicked)
lst = etk.List(model, selectable=True, animated_changes=True,row_height=100,
columns=[(480,ktr,True)])

gps=gps()
bt=bt()
gsm=gsm()
for item in ['GSM', 'WiFi', 'Bluetooth', 'GPS', 'Display', 'Sound Effects',
'Ringtones', 'Vibrate']:
	lst.freeze()
	model.append([item, label_text(item)])
	lst.thaw()

main_box.append(lst, etk.VBox.START, etk.VBox.EXPAND_FILL, 0)
w = etk.Window(title="Settings", size_request=(480, 300), child=main_box)
w.on_destroyed(lambda x: etk.main_quit())
w.show_all()
etk.main()
